import { Component, OnInit, OnDestroy, ElementRef } from "@angular/core";
// import { gantt } from 'dhtmlx-gantt';

import "dhtmlx-gantt";

declare let gantt: any;
import "./export_api.js";

@Component({
  selector: "app-gantt",
  templateUrl: "./gantt.component.html",
  styleUrls: ["./gantt.component.css"],
  template: `<div #gantt_here class="gantt-chart"></div>`,
})
export class GanttComponent implements OnInit {
  constructor(
    private elementRef: ElementRef
  ) {  }

  ngOnInit(): void {
    window.addEventListener('click', function(e:any){   
      if (e.target.className == "export"){
        gantt.exportToPDF()
      }
    });
    
    const taskData = {
      data: [
        {
          id: "10",
          text: "Project #1",
          start_date: "01-04-2025",
          duration: 3,
          progress: 0.4,
          open: true,
          select: "Select 1",
        },
        {
          id: "1",
          text: "Task #1",
          start_date: "02-04-2025",
          duration: 2,
          progress: 0.6,
          parent: "10",
          select: "Select 1",
        },
        {
          id: "2",
          text: "Task #2",
          start_date: "01-04-2025",
          duration: 2,
          progress: 0.6,
          parent: "10",
          select: "Select 1",
        },
        {
          id: "20",
          text: "Project #2",
          start_date: "01-04-2025",
          duration: 3,
          progress: 0.4,
          type: "project",
          open: true,
          select: "Select 1",
        },
        {
          id: "3",
          text: "Task #3",
          start_date: "02-04-2025",
          duration: 2,
          progress: 0.6,
          parent: "20",
          select: "Select 1",
        },
        {
          id: "4",
          text: "Task #4",
          start_date: "01-04-2025",
          duration: 2,
          progress: 0.6,
          parent: "20",
          select: "Select 1",
        },
      ],
      links: [
        { id: 1, source: 1, target: 2, type: "0" },
        { id: 2, source: 2, target: 3, type: "0" },
        { id: 3, source: 3, target: 4, type: "0" },
        { id: 4, source: 2, target: 5, type: "0" },
      ],
    };

    gantt.init("gantt_here");

    gantt.parse(taskData);
  }
}
